package com.database

import static com.kms.katalon.core.checkpoint.CheckpointFactory.findCheckpoint
import static com.kms.katalon.core.testcase.TestCaseFactory.findTestCase
import static com.kms.katalon.core.testdata.TestDataFactory.findTestData
import static com.kms.katalon.core.testobject.ObjectRepository.findTestObject
import com.kms.katalon.core.annotation.Keyword
import com.kms.katalon.core.checkpoint.Checkpoint
import com.kms.katalon.core.cucumber.keyword.CucumberBuiltinKeywords as CucumberKW
import com.kms.katalon.core.mobile.keyword.MobileBuiltInKeywords as Mobile
import com.kms.katalon.core.model.FailureHandling
import com.kms.katalon.core.testcase.TestCase
import com.kms.katalon.core.testdata.TestData
import com.kms.katalon.core.testobject.TestObject
import com.kms.katalon.core.webservice.keyword.WSBuiltInKeywords as WS
import com.kms.katalon.core.webui.keyword.WebUiBuiltInKeywords as WebUI
import java.sql.ResultSet
import java.sql.SQLException

import internal.GlobalVariable

public class dbEdit {

	/**
	 * 
	 * Receives an ColumnNam and number of days to move the starting/ending dates (negative number to move back, positive number to move forward) .
	 * If record is in table, sets the starting and ending dates back by set number of days,
	 * If record is in table, also sets back dates in and Log tables
	 * 
	 */


	@Keyword
	def moveItemDate(columnm, moveDays){

		def dbURL = <IP>
		def dbPort =  '6700'
		def dbUsername = 'Usernm'
		def dbPassword = 'Usernm.pswd'
		def dbName = domainNm

		def sql_Server = new com.database.sqlServer()


		/** check if ColumnNamexists in Items table*/
		sql_Server.connectDB(dbURL, dbPort, dbName, dbUsername, dbPassword) //open db connection

		def ResultSet itemsCount = sql_Server.executeQuery(

				''' SELECT COUNT(*)
				  FROM tablnm
				 WHERE ColumnNam= ''' + ColumnNam+ '''
			'''
				)

		itemsCount.next()
		def itemTableCount = itemsCount.getInt(1)

		if (itemTableCount==1){//check if record is in Items table, move record dates if it is

			try{


				def updateItems = sql_Server.execute('''
						 UPDATE tableNm
							SET ColumnNam= DATEADD(DAY, ''' + moveDays + ''', ColumnNm),
							    ColumnNam= DATEADD(DAY, ''' + moveDays + ''', ColumnNm)
						  WHERE ColumnNam= ''' + ColumnNam+ ''' 
				    ''')

			}
			catch(SQLException se){
				println('Update table failed with ' + se)
			}

			println('>>>> Table has been updated')

		}

		else {

			def itemArchiveCount = sql_Server.executeQuery('''
					SELECT COUNT(*)
	                  FROM tablnm
					 WHERE ColumnNam= ''' + ColumnNam+ '''
	
			''')

			itemArchiveCount.next()
			def itemArchiveTableCount = itemArchiveCount.getInt(1)

			if(itemArchiveTableCount == 1){//check if record is in table, move records dates in and tables

				try{//update  Table
					def updateItems = sql_Server.execute(''' 
							 UPDATE tablnm
								SET ColumnNam= DATEADD(DAY, ''' + moveDays + ''', ColumnNam),
							   ColumnNam= DATEADD(DAY, ''' + moveDays + ''', ColumnNam)
							  WHERE ColumnNam= ''' + ColumnNam+ ''' 
	   
			   ''')

					//update Table
					//					def updateOrders = sql_Server.execute('''
					//							 UPDATE tablnm
					//								SET OrderDate = DATEADD(DAY, ''' + moveDays + ''', OrderDate)
					//	                		  WHERE columnNm= (SELECT columnNmFROM dbo.OrderItems WHERE ColumnNam= ''' + ColumnNam+ ''' )
					//
					//			  ''')


					//update Table
					//					def updateSalesLog = sql_Server.execute('''
					//							 UPDATE tablenm
					//								SET DateTime = DATEADD(DAY, ''' + moveDays + ''', DateTime)
					//							  WHERE ColumnNam= ''' + ColumnNam+ '''
					//
					//			  ''')

				}
				catch(SQLException se){
					println('Update ItemArchive process failed with ' + se)
				}

				//println('>>>> table, table, table have all been updated')
				println(' (or table has been updated for ' + columnm)

				//close DB connection
				sql_Server.closeDatabaseConnection()

			} //end Update
			else{println('Provided ColumnNamwas not found in DB. Check your data')}

		}
		//println('tables have been updated, dates have been moved ' + moveDays + 'days.')
		println('table has been updated, dates have been moved ' + moveDays + 'days for ' + columnm)
	}//end MoveDateItem Method


	/**
	 *
	 * Receives a table name, column name, column value and number of days to move.
	 * Negative number to move back, positive number to move forward .
	 *
	 */


	@Keyword
	def moveTableDate(tableName, updateColumnName, keyColumnName, keyColumnValue, daysMove){

		def dbURL = 'IP'
		def dbPort =  '6700'
		def dbUsername = 'Usernm'
		def dbPassword = 'Usernm.pswd'
		def dbName = domainNm

		def sql_Server = new com.database.sqlServer()


		sql_Server.connectDB(dbURL, dbPort, dbName, dbUsername, dbPassword) //open db connection

		def updateTable = sql_Server.execute('''
							 UPDATE ''' + tableName + '''
								SET ''' + updateColumnName + ''' = DATEADD(DAY, ''' + daysMove + ''', ''' + updateColumnName + ''')
							  WHERE ''' + keyColumnName + ''' = ''' + keyColumnValue + ''' 

			''')
		println(tableName + 'has been updated. ' + updateColumnName + ' has been moved ' + daysMove + ' days.')
	}
}
